﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using OpenPop.Mime;

namespace Org.SSRSPreview
{
    public class ReportConvertor
    {
        public static byte[] Convert(byte[] Content)
        {
            var message = new Message(Content);
            var body = message.FindFirstHtmlVersion();
            var bodyText = body.BodyEncoding.GetString(body.Body, 0, body.Body.Length);
            message.FindAllAttachments().ForEach(a =>
                {
                    if (!a.IsText)
                    {
                        var key = "Content-Location";
                        var url = a.Headers.UnknownHeaders[key];
                        if (string.IsNullOrEmpty(url) && a.ContentDisposition != null)
                            url = a.ContentDisposition.Inline ? "cid:" + a.FileName : a.FileName;
                        var attachment = a.Body;

                        var embedImage = new StringBuilder("data:");
                        embedImage.Append(a.ContentType.MediaType + ";");
                        embedImage.Append(a.ContentTransferEncoding.ToString().ToLowerInvariant() + ",");
                        embedImage.Append(a.BodyEncoding.GetString(a.RawBody));
                        bodyText = bodyText.Replace(url, embedImage.ToString());
                    }
                });
            return body.BodyEncoding.GetBytes(bodyText);
        }
    }
}
